//+------------------------------------------------------------------+
//|                             normalized deviations oscillator.mq4 |
//|                                                           mladen |
//|                                                                  |
//| original developed by William Cringan (TASC 2/2003)              |
//+------------------------------------------------------------------+

#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    3
#property indicator_color1     DeepSkyBlue
#property indicator_width1     1
#property indicator_color2     PaleVioletRed
#property indicator_width2     1
#property indicator_color3     Gold
#property indicator_width3     1
#property indicator_level1     25
#property indicator_level2     50
#property indicator_level3     75
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern string TimeFrame    = "Current time frame";
extern int    NdoPrice     = PRICE_CLOSE;
extern int    EMAPeriod    = 12;
extern int    AtrPeriod    = 12;
extern int    SigMaPeriod  = 3;
extern int    Ma_Mode      = MODE_SMMA;
extern int    NormPeriod   = 100;
extern int    SmoothLength = 5;
extern double SmoothPhase  = 0;
extern bool   SmoothDouble = false;
extern bool   Interpolate  = true;

//
//
//
//
//

double ndo[];
double natr[];
double ndma[];
double dos[];
double atr[];
double temp[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,ndo);
   SetIndexBuffer(1,natr);
   SetIndexBuffer(2,ndma);
   SetIndexBuffer(3,dos);
   SetIndexBuffer(4,atr);
   SetIndexBuffer(5,temp);
   
   //
   //
   //
   //
   //
    
   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
      
   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+"   norm deviations + atr  ("+EMAPeriod+","+AtrPeriod+","+SigMaPeriod+")");
 return(0);
}

//
//
//
//
//

int deinit() {   return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,s,n,limit;

   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
          limit = MathMin(Bars-counted_bars,Bars-1);
          if (returnBars) { ndo[0] = limit+1; return(0); }
    
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
         
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      
      double h  = High[i];
      double l  = Low[i];
      
      if(i == Bars-1) 
      temp[i] = h - l;
      
      else
      {
      
      double c = Close[i+1];
      temp[i]  = MathMax(h,c) - MathMin(l,c);
      }
   }
   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      atr[i] = iMAOnArray(temp,Bars,AtrPeriod,0,Ma_Mode,i);
      dos[i] = iMA(NULL,0,1,0,MODE_SMA,NdoPrice,i) - iMA(NULL,0,EMAPeriod,0,MODE_EMA,NdoPrice,i);
      
         //
         //
         //
         //
         //
         
         
         double hi     = 0.0000001;
         double lo     = 1000000;
         double MaxAtr = 0.0000001;
         double MinAtr = 1000000;
         
         for( int k=0; k < NormPeriod - 1 ; k++)
         {
         MaxAtr = MathMax(MaxAtr,atr[i+k]);
         MinAtr = MathMin(MinAtr,atr[i+k]); 
         hi     = MathMax(hi,dos[i+k]);
         lo     = MathMin(lo,dos[i+k]);           
         }
         
         if (hi - lo > 0)
                    ndo[i]  = iDSmooth(100*(dos[i]- lo)/(hi - lo),SmoothLength,SmoothPhase,SmoothDouble,i, 0);        
                     
         if (MaxAtr - MinAtr > 0)
                    natr[i] = iDSmooth(100*(atr[i]-MinAtr)/(MaxAtr-MinAtr),SmoothLength,SmoothPhase,SmoothDouble,i,20);
          
          }
          
          //
          //
          //
          //
          //
          
          for (i=limit; i>=0; i--) ndma[i] = iMAOnArray(ndo,Bars,SigMaPeriod,0,Ma_Mode,i);             
                          
                     
   
     return(0);         
}
          
    //
    //
    //
    //
    //
    
    limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    for (i=limit;i>=0; i--)
    {
       int y = iBarShift(NULL,timeFrame,Time[i]);
            ndo[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,AtrPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,0,y);
            natr[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,AtrPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,1,y);
            ndma[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,AtrPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothLength,SmoothPhase,SmoothDouble,2,y);
            
            //
            //
            //
            //
            //
            
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(s = 1; s < n; s++)
            {
  	            ndo[i+s]  = ndo[i]  + (ndo[i+n]  - ndo[i])  * s/n;
  	            natr[i+s] = natr[i] + (natr[i+n] - natr[i]) * s/n;
  	            ndma[i+s] = ndma[i] + (ndma[i+n] - ndma[i]) * s/n;
  	  
           }  	            
   }
      
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
   
}

//+------------------------------------------------------------------
//|                                                                 
//+------------------------------------------------------------------
//
//
//
//
//

double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}